apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ ara_name }}
  name: {{ ara_job_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ ara_job_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ ara_job_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ ara_job_name }}
    spec:
{% if do_affinities %}
      affinity:
        podAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ ara_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ ara_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - /job.sh
        command:
        - /usr/bin/dumb-init
        env:
        - name: ARA_PRUNE_COMPLETED_AFTER
          value: "{{ ara_retention_completed }}"
        - name: ARA_PRUNE_PENDING_AFTER
          value: "{{ ara_retention_pending }}"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: JOB_INTERVAL
          value: "{{ ara_job_interval }}"
        - name: POSTGRES_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ara_pg_name }}
        - name: POSTGRES_HOST
          value: {{ ara_pg_name }}
        - name: POSTGRES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ara_pg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ara_pg_name }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='ara'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='ara'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: job
        resources:
          limits:
            cpu: {{ ara_cpu_limit }}
            memory: {{ ara_memory_limit }}
          requests:
            cpu: {{ ara_cpu_request }}
            memory: {{ ara_memory_request }}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /.ara
          name: temp
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      volumes:
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='ara'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - job
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='ara'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
